#ifndef MOBIES_CROSSLINKS_H
#define MOBIES_CROSSLINKS_H
// header file Crosslinks.h generated from diagram Crosslinks
// generated on Wed Oct 05 16:58:14 2005

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace ExtendedMOF
{ 
	 class  GMEClass;
	 class  GMEParadigmSheet;
	 class  GMEFCO;
	 class  GMEAttribute;
	 class  GMEConstraint;
	 class  GMEConnection;
	 class  SameAspectLeft;
	 class  Aspect;
	 class  AspectProxy;
	 class  AspectBase;
	 class  SameAspectBase;
	 class  SameAspect;
	 class  SameAspectRight;
	 class  HasAspect;
	 class  NoAggregation;
	 class  CompositeAggregation;
	 class  Association;
	 class  End1;
	 class  End2;
	 class  AssociationEnd;
	 class  Constant;
	 class  Import;
	 class  Package;
	 class  NestedPackage;
	 class  PContainer;
	 class  PackageSheet;
	 class  IsOfType;
	 class  StructureField;
	 class  AliasType;
	 class  EnumerationType;
	 class  CollectionType;
	 class  PrimitiveType;
	 class  DataType;
	 class  StructureType;
	 class  DataTypeProxy;
	 class  Namespace;
	 class  Container;
	 class  Operation;
	 class  Exception;
	 class  Class;
	 class  Parameter;
	 class  ExceptionProxy;
	 class  ExceptionType;
	 class  CanRaise;
	 class  Attribute;
	 class  ClassType;
	 class  ClassProxy;
	 class  BehavioralFeature;
	 class  Feature;
	 class  Classifier;
	 class  TypedElement;
	 class  ModelElement;
	 class  GeneralizableElement;
	 class  Constraint;
	 class  Constrains;
	 class  AttachesTo;
	 class  Tag;
	 class  Subtype;
	 class  Supertype;
	 class  Inheritance;
	 class  MgaObject;
};
namespace MetaGME
{ 
	 class  Folder;
	 class  FolderContainment;
	 class  FolderProxy;
	 class  BaseFolder;
	 class  FCOProxy;
	 class  FCOBase;
	 class  Containment;
	 class  SheetFolder;
	 class  BaseAtom;
	 class  AtomProxy;
	 class  ModelProxy;
	 class  BaseFCOClass;
	 class  FCO;
	 class  Atom;
	 class  ProxyBase;
	 class  ContainedInPar;
	 class  BaseFCO;
	 class  Model;
	 class  BaseModel;
	 class  BelongsToAspect;
	 class  ParadigmSheet;
	 class  BaseSet;
	 class  SetProxy;
	 class  SetMembership;
	 class  Set;
	 class  BaseReference;
	 class  ReferTo;
	 class  ReferenceProxy;
	 class  Reference;
	 class  EquivRight;
	 class  SameFolderBase;
	 class  SameAspectLeft;
	 class  SameAspectRight;
	 class  SameFolder;
	 class  SameFolderRight;
	 class  SameAspectBase;
	 class  Equivalence;
	 class  EquivLeft;
	 class  SameAspect;
	 class  SameFolderLeft;
	 class  EquivalenceBase;
	 class  EqOperatorBase;
	 class  FCOConstraintBase;
	 class  Connector;
	 class  AssociationClass;
	 class  ConnectionProxy;
	 class  BaseConnection;
	 class  Connection;
	 class  SourceToConnector;
	 class  ConnectorToDestination;
	 class  Constraint;
	 class  HasConstraint;
	 class  ConstraintFunc;
	 class  ImplementationInheritance;
	 class  DerivedInheritance;
	 class  DerivedIntInheritance;
	 class  DerivedImpInheritance;
	 class  InheritOperator;
	 class  BaseInheritance;
	 class  InterfaceInheritance;
	 class  Inheritance;
	 class  BaseIntInheritance;
	 class  BaseImpInheritance;
	 class  FieldAttribute;
	 class  HasAttribute;
	 class  Attribute;
	 class  EnumAttribute;
	 class  BooleanAttribute;
	 class  HasAspect;
	 class  AspectProxy;
	 class  AspectBase;
	 class  Aspect;
	 class  MgaObject;
};


namespace Crosslinks {

	class  RootFolder;
	class  RegistryEntry;

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		RootFolder(const RootFolder &master) : UDM_OBJECT(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<Crosslinks::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Crosslinks::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<Crosslinks::RootFolder> Derived() { return Udm::DerivedAttr<Crosslinks::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<Crosslinks::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Crosslinks::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<Crosslinks::RootFolder> Archetype() { return Udm::ArchetypeAttr<Crosslinks::RootFolder>(impl);}

		static Uml::CompositionChildRole meta_RegistryEntry_children;
		Udm::ChildrenAttr<Crosslinks::RegistryEntry> RegistryEntry_children() const { return Udm::ChildrenAttr<Crosslinks::RegistryEntry>(impl, meta_RegistryEntry_children); }
		 template <class Pred> Udm::ChildrenAttr<Crosslinks::RegistryEntry, Pred> RegistryEntry_children_sorted(const Pred &) const { return Udm::ChildrenAttr<Crosslinks::RegistryEntry, Pred>(impl, meta_RegistryEntry_children); }

		Udm::ChildrenAttr<Crosslinks::RegistryEntry> RegistryEntry_kind_children() const { return Udm::ChildrenAttr<Crosslinks::RegistryEntry>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<Crosslinks::RegistryEntry, Pred> RegistryEntry_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<Crosslinks::RegistryEntry, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  RegistryEntry :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		RegistryEntry() { }
		RegistryEntry(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		RegistryEntry(const RegistryEntry &master) : UDM_OBJECT(master) { }
		static RegistryEntry Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RegistryEntry Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RegistryEntry CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RegistryEntry CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RegistryEntry> Instances() { return Udm::InstantiatedAttr<Crosslinks::RegistryEntry>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RegistryEntry, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Crosslinks::RegistryEntry, Pred>(impl);}

		Udm::DerivedAttr<Crosslinks::RegistryEntry> Derived() { return Udm::DerivedAttr<Crosslinks::RegistryEntry>(impl);}
		template <class Pred> Udm::DerivedAttr<Crosslinks::RegistryEntry, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Crosslinks::RegistryEntry, Pred>(impl);}

		Udm::ArchetypeAttr<Crosslinks::RegistryEntry> Archetype() { return Udm::ArchetypeAttr<Crosslinks::RegistryEntry>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::AssociationRole meta_element;
		Udm::CrossAssocAttr<ExtendedMOF::MgaObject> element() const { return Udm::CrossAssocAttr<ExtendedMOF::MgaObject>(impl, meta_element); }
		template<class Pred> Udm::CrossAssocAttr<ExtendedMOF::MgaObject, Pred> element_sorted(const Pred &) const { return Udm::CrossAssocAttr<ExtendedMOF::MgaObject, Pred>(impl, meta_element); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<Crosslinks::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<Crosslinks::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<Crosslinks::RootFolder> parent() const { return Udm::ParentAttr<Crosslinks::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_CROSSLINKS_H
