// cpp(meta datanetwork format) source file Crosslinks.cpp generated from diagram Crosslinks
// generated on Wed Oct 05 16:58:14 2005

#include "Crosslinks.h"
#include "UmlExt.h"

#include "UdmStatic.h"

// cross-package metainformation header file
#include "MOF2MetaGME.h"

namespace Crosslinks {

	Uml::Diagram umldiagram;

	Uml::Class RootFolder::meta;
	Uml::Class RegistryEntry::meta;
	Uml::Attribute RegistryEntry::meta_name;
	Uml::AssociationRole RegistryEntry::meta_element;
	Uml::CompositionParentRole RegistryEntry::meta_RootFolder_parent;
	Uml::CompositionChildRole RootFolder::meta_RegistryEntry_children;
	void Creates()
	{
		RootFolder::meta = Uml::Class::Create(umldiagram);
		RegistryEntry::meta = Uml::Class::Create(umldiagram);
		RegistryEntry::meta_name = Uml::Attribute::Create(RegistryEntry::meta);
	}
	void InitClassesAttributes()
	{
		RootFolder::meta.name() = "RootFolder";
		RootFolder::meta.isAbstract() = false;
		RegistryEntry::meta.name() = "RegistryEntry";
		RegistryEntry::meta.isAbstract() = false;
		
		RegistryEntry::meta_name.name() = "name";
		RegistryEntry::meta_name.type() = "String";
		RegistryEntry::meta_name.min() = 0;
		RegistryEntry::meta_name.max() = 1;
		RegistryEntry::meta_name.nonpersistent() = false;
		RegistryEntry::meta_name.registry() = false;
		RegistryEntry::meta_name.ordered() = false;
		RegistryEntry::meta_name.visibility() = "public";
		RegistryEntry::meta_name.defvalue() = vector<string>();
		
	}
	void InitComposition0()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		RegistryEntry::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
		RegistryEntry::meta_RootFolder_parent.name() = "RootFolder_parent";
		RegistryEntry::meta_RootFolder_parent.isNavigable() = true;
		RegistryEntry::meta_RootFolder_parent.target() = RootFolder::meta;
		RootFolder::meta_RegistryEntry_children = Uml::CompositionChildRole::Create(comp);
		RootFolder::meta_RegistryEntry_children.name() = "RegistryEntry";
		RootFolder::meta_RegistryEntry_children.min() = 0;
		RootFolder::meta_RegistryEntry_children.max() = -1;
		RootFolder::meta_RegistryEntry_children.isNavigable() = true;
		RootFolder::meta_RegistryEntry_children.target() = RegistryEntry::meta;
	}
	 void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		MOF2MetaGME::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("Crosslinks.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="Crosslinks";
		umldiagram.version() ="1.00";
		Creates();
		InitClassesAttributes();
		Uml::InitDiagram(umldiagram, "Crosslinks", "1.00");

		InitComposition0();
		RegistryEntry::meta_element = MOF2MetaGME::RegistryEntry_cross_ph_Crosslinks::meta_element;
		
	}
	 void Initialize(const Uml::Diagram & dgr)
	{
		umldiagram = dgr;
		Uml::SetClass(RootFolder::meta, umldiagram, "RootFolder");
		Uml::SetClass(RegistryEntry::meta, umldiagram, "RegistryEntry");
		Uml::SetAttribute(RegistryEntry::meta_name,RegistryEntry::meta, "name");
		//composition child roles 
		Uml::SetParentRole(RegistryEntry::meta_RootFolder_parent,RegistryEntry::meta,RootFolder::meta, "", "");
		// composition parentroles 
		Uml::SetChildRole(RootFolder::meta_RegistryEntry_children,RootFolder::meta,RegistryEntry::meta, "", "");
		// Association roles 


		
	}
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("Crosslinks", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("Crosslinks");
		};
	} __regUnUsed;

}
// END Crosslinks.cpp
